﻿<?xml version="1.0" encoding="utf-8"?>
<pattern id="Content" xmlns="http://purl.oclc.org/dsdl/schematron">
    <title>Content Validations</title>

    <rule context="xbrli:xbrl[not(@i:nil='true' or @i:nil='1')]/pyin.02.00:Report.TargetFinancial.Year[not(@i:nil='true' or @i:nil='1')]">
        <!-- 
        
        IF [TPAR47] <> NULL AND [TPAR47] < 2013
         RETURN VALIDATION MESSAGE
        ENDIF
 
        [TPAR47] = TPAR:RP:pyin.02.00:Report.TargetFinancial.Year
        -->

        <assert id="VR.ATO.TPAR.000029" diagnostics="DVR.ATO.TPAR.000029"
                test="not(
                            @contextRef = @contextRef = $RP.ContextId and (number(.) &lt; 2013)
                           )" />

        <!--
            IF [TPAR47] <> NULL AND [TPAR47] > CURRENT FINANCIAL YEAR
            RETURN VALIDATION MESSAGE
            ENDIF 
            [TPAR47] = TPAR:RP:pyin.02.00:Report.TargetFinancial.Year
        -->
       
        <assert id="VR.ATO.TPAR.000044" diagnostics="DVR.ATO.TPAR.000044"
               test="not(
                            @contextRef = @contextRef = $RP.ContextId and (number(.) &gt;function:DateToFinancialYear(date:date-time()) )
                           )" />


    </rule>
    
    <rule context="phone1.02.00:ElectronicContactTelephone[not(@i:nil='true' or @i:nil='1')]">

        <!--
            WHERE IN TUPLE(electroniccontacttelephone1.xx.xx:ElectronicContactTelephone)
            IF pyde.xx.xx:ElectronicContact.Telephone.Minimal.Number = NULL OR pyde.xx.xx:ElectronicContact.Telephone.Usage.Code <> "03" OR pyde.xx.xx:Electronic Contact.Telephone.ServiceLine.Code <> SET ("01", "02")
               RETURN VALIDATION MESSAGE
            ENDIF   
        --> 
        <assert id="VR.ATO.GEN.432016" diagnostics="DVR.ATO.GEN.432016"
                test="not(
                        not (pyde.02.00:ElectronicContact.Telephone.Minimal.Number[not(@i:nil='true' or @i:nil='1')])
                        or  (pyde.02.00:ElectronicContact.Telephone.Usage.Code[not(@i:nil='true' or @i:nil='1')] != '03')
                        or  (pyde.02.00:ElectronicContact.Telephone.ServiceLine.Code[not(@i:nil='true' or @i:nil='1') 
                               and not(regexp:test(.,'^(01|02)$'))])
                      )"/>
    </rule>


    
    <rule context="prsnunstrcnm1.02.01:PersonUnstructuredName[not(@i:nil='true' or @i:nil='1')]">
        <!--
            WHERE IN TUPLE (personunstructuredname1.xx.xx:PersonUnstructuredName)
            IF (pyde.xx.xx:PersonUnstructuredName.Usage.Code <> "Contact")
                RETURN VALIDATION MESSAGE
            ENDIF
        -->
        <assert id="VR.ATO.TPAR.000014" diagnostics="DVR.ATO.TPAR.000014"
                test="not(
                         pyde.02.05:PersonUnstructuredName.Usage.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) != 'CONTACT']
                        )"/>       
        
       
    </rule>

    <rule context="fax1.02.00:ElectronicContactFacsimile[not(@i:nil='true' or @i:nil='1')]">
        <!--
            WHERE IN TUPLE (fax1.xx.xx:ElectronicContactFacsimile)
            IF (pyde.xx.xx:ElectronicContact.Facsimile.Usage.Code <>"03") OR (pyde.xx.xx:ElectronicContact.Facsimile.Minimal.Number = BLANK)
               RETURN VALIDATION MESSAGE
            ENDIF 
        -->
        <assert id="VR.ATO.GEN.438008" diagnostics="DVR.ATO.GEN.438008"
                test="not(
                         pyde.02.00:ElectronicContact.Facsimile.Usage.Code[not(@i:nil='true' or @i:nil='1') and . != '03']
                         or 
                         pyde.02.00:ElectronicContact.Facsimile.Minimal.Number[string-length(normalize-space(.)) = 0]
                        )"/>
    </rule>

   
    <rule context="address2.02.02:AddressDetails[not(@i:nil='true' or @i:nil='1')]">
        <!--
            WHERE IN TUPLE(addressdetails2.xx.xx:AddressDetails)
            IF (pyde.xx.xx:AddressDetails.OverseasAddress.Indicator = NULLORBLANK)
              RETURN VALIDATION MESSAGE
            ENDIF  
        --> 
        <assert id="VR.ATO.GEN.410167" diagnostics="DVR.ATO.GEN.410167"
             test=" pyde.02.00:AddressDetails.OverseasAddress.Indicator[not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0]
                  "/>

        <!--
             
            WHERE IN TUPLE (address2.xx.xx:AddressDetails)
            IF (pyde.xx.xx:AddressDetails.Usage.Code <>  SET("POS","BUS")) OR (pyde.xx.xx:AddressDetails.Currency.Code <> "C")
             RETURN VALIDATION MESSAGE
            ENDIF

        -->
        <assert id="VR.ATO.TPAR.000019" diagnostics="DVR.ATO.TPAR.000019"
                test="not(
                         pyde.02.01:AddressDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and not(regexp:test(exslt:uppercase(.),'^(POS|BUS)$'))]
                         or
                         pyde.02.00:AddressDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) != 'C']
                        )"/>


        <!--
            IF [TPAR27] <> NULL AND [TPAR27] <> SET ("ACT","NSW","NT","QLD","SA","VIC","WA","TAS")
                RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR27] = TPAR:INT:pyde.02.00:AddressDetails.StateOrTerritory.Code WHERE 
            (pyde.02.01:AddressDetails.Usage.Code = "BUS" AND pyde.02.00:AddressDetails.Currency.Code = "C") 
            IN TUPLE(address2.02.02:AddressDetails)

        -->
        <assert id="VR.ATO.TPAR.000023" diagnostics="DVR.ATO.TPAR.000023"
                test="not(
                         pyde.02.00:AddressDetails.StateOrTerritory.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and not(regexp:test(exslt:uppercase(normalize-space(.)),'^(?i)(QLD|NSW|VIC|SA|WA|NT|ACT|TAS)$'))]
                         and
                         pyde.02.01:AddressDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and exslt:uppercase(.) = 'BUS']
                         and
                         pyde.02.00:AddressDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and exslt:uppercase(.) = 'C']
                        )"/>

        <!--
            IF [TPAR18] = FALSE AND ([TPAR26] = NULL OR [TPAR27] = NULL)
            RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR18] = TPAR:INT:pyde.02.00:AddressDetails.OverseasAddress.Indicator WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" AND pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
            [TPAR26] = TPAR:INT:pyde.02.00:AddressDetails.Postcode.Text WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" AND pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
            [TPAR27] = TPAR:INT:pyde.02.00:AddressDetails.StateOrTerritory.Code WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" AND pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
        -->
        <assert id="VR.ATO.TPAR.000018" diagnostics="DVR.ATO.TPAR.000018"
              test="not(
                        ( 
                         pyde.02.00:AddressDetails.OverseasAddress.Indicator[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and regexp:test(.,'^(false|0)$')]
                         and
                         pyde.02.01:AddressDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and exslt:uppercase(.) = 'BUS']
                         and
                         pyde.02.00:AddressDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and exslt:uppercase(.) = 'C']
                        ) 
                        and
                        (
                            (   
                                not(pyde.02.00:AddressDetails.Postcode.Text[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId])
                                and
                                pyde.02.01:AddressDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and exslt:uppercase(.) = 'BUS']
                                and
                                pyde.02.00:AddressDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and exslt:uppercase(.) = 'C']
                             )
                            or
                            (   not(pyde.02.00:AddressDetails.StateOrTerritory.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId])
                                and
                                pyde.02.01:AddressDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and exslt:uppercase(.) = 'BUS']
                                and
                                pyde.02.00:AddressDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and exslt:uppercase(.) = 'C']
                            )                
                        )
                       )"/>

        <!--
            IF [TPAR18] = TRUE AND [TPAR29] = NULL
            RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR18] = TPAR:INT:pyde.02.00:AddressDetails.OverseasAddress.Indicator 
            WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" 
            AND pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
            [TPAR29] = TPAR:INT:pyde.02.08:AddressDetails.Country.Code 
            WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" 
            AND pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)  

            -->
        <assert id="VR.ATO.TPAR.000024" diagnostics="DVR.ATO.TPAR.000024"
                test="not(                        
                           pyde.02.00:AddressDetails.OverseasAddress.Indicator[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and regexp:test(.,'^(true|1)$')]
                           and pyde.02.01:AddressDetails.Usage.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'BUS']
                           and pyde.02.00:AddressDetails.Currency.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] 
                           and not(pyde.02.08:AddressDetails.Country.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0])
                           
                        )" />
        
    </rule>

    <rule context="email1.02.00:ElectronicContactElectronicMail[not(@i:nil='true' or @i:nil='1')]">
        <!--
            WHERE IN TUPLE(ElectronicContactElectronicMail1.xx.xx:ElectronicContactElectronicMail)
            IF (pyde.xx.xx:ElectronicContact.ElectronicMail.Address.Text = NULLORBLANK) OR (pyde.xx.xx:ElectronicContact.ElectronicMail.Usage.Code <> "03") 
            RETURN VALIDATION MESSAGE
            ENDIF

        -->
        <assert id="VR.ATO.GEN.436276" diagnostics="DVR.ATO.GEN.436276"
                test="not(
                        not(pyde.02.00:ElectronicContact.ElectronicMail.Address.Text[not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0])
                        or (pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code[not(@i:nil='true' or @i:nil='1')] != '03')
                      )" />

    </rule>
    
    
    <rule context="declaration1.02.01:Declaration[not(@i:nil='true' or @i:nil='1')]">
        <!--    
           WHERE IN TUPLE(declaration1.xx.xx:Declaration)
            IF (pyin.xx.xx:Declaration.StatementType.Code <> "TrueAndCorrect") OR (pyin.xx.xx:Declaration.StatementAccepted.Indicator = FALSE) OR  (pyin.xx.xx:Declaration.Signature.Date = NULL) 
               RETURN VALIDATION MESSAGE
            ENDIF
        -->
        <assert id="VR.ATO.TPAR.000042" diagnostics="DVR.ATO.TPAR.000042"
                test="not(
                        pyin.02.03:Declaration.StatementType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) != 'TRUEANDCORRECT']
                        or
                        pyin.02.00:Declaration.StatementAccepted.Indicator[not(@i:nil='true' or @i:nil='1') and regexp:test(.,'^(false|0)$')]
                        or
                        not(pyin.02.00:Declaration.Signature.Date[not(@i:nil='true' or @i:nil='1')])                         
                        )" />

    </rule>
    
    
    <rule context="prsnstrcnm3.02.01:PersonNameDetails[not(@i:nil='true' or @i:nil='1')]">
            <!--
            WHERE IN TUPLE(prsnstrcnm3.xx.xx:PersonNameDetails) 
            IF (pyde.xx.xx:PersonNameDetails.PersonNameType.Code <> "LGL") 
            OR (pyde.xx.xx:PersonNameDetails.Currency.Code <> "C") 
            OR (pyde.xx.xx:PersonNameDetails.Usage.Code <> "Identifier")
               RETURN VALIDATION MESSAGE
            ENDIF
            -->
        <assert id="VR.ATO.TPAR.000034" diagnostics="DVR.ATO.TPAR.000034"
                test="not(
                        pyde.02.00:PersonNameDetails.PersonNameType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) != 'LGL']
                        or
                        pyde.02.00:PersonNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) != 'C']
                        or
                        pyde.02.05:PersonNameDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) != 'IDENTIFIER']                 
                        )" />

    </rule>
    
    <rule context="orgname2.02.00:OrganisationNameDetails[not(@i:nil='true' or @i:nil='1')]">
        <!--
            WHERE IN TUPLE (orgname2.xx.xx:OrganisationNameDetails)
            IF (pyde.xx.xx:OrganisationNameDetails.OrganisationalNameType.Code <> SET("MN" ,"MTR")) 
            OR (pyde.xx.xx:OrganisationNameDetails.Currency.Code <> "C")
             RETURN VALIDATION MESSAGE
            ENDIF  

            -->
        <assert id="VR.ATO.TPAR.000031" diagnostics="DVR.ATO.TPAR.000031"
                test="not(
                        pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code[not(@i:nil='true' or @i:nil='1') and not(regexp:test(exslt:uppercase(.),'^(MN|MTR)$'))]
                        or
                        pyde.02.00:OrganisationNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) != 'C']
                        )" />

    </rule>

    <!--<rule context="xbrli:xbrl[not(@i:nil='true' or @i:nil='1')]/address2.02.02:AddressDetails[not(@i:nil='true' or @i:nil='1')]">-->
        <!--
            IF [TPAR18] = TRUE AND [TPAR29] = NULL
            RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR18] = TPAR:INT:pyde.02.00:AddressDetails.OverseasAddress.Indicator 
            WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" 
            AND pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
            [TPAR29] = TPAR:INT:pyde.02.08:AddressDetails.Country.Code 
            WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" 
            AND pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)  

            -->
        <!--<assert id="VR.ATO.TPAR.000024" diagnostics="DVR.ATO.TPAR.000024"
                test="not(                        
                           pyde.02.00:AddressDetails.OverseasAddress.Indicator[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and regexp:test(.,'^(true|1)$')]
                           and pyde.02.01:AddressDetails.Usage.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'BUS']
                           and pyde.02.00:AddressDetails.Currency.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] 
                           and not(pyde.02.08:AddressDetails.Country.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0])
                            ]
                        )" />-->
        <!--<assert id="VR.ATO.TPAR.000024" diagnostics="DVR.ATO.TPAR.000024"
                test="not(
                           address2.02.02:AddressDetails[
                           not(@i:nil='true' or @i:nil='1') and
                           ./pyde.02.00:AddressDetails.OverseasAddress.Indicator[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and regexp:test(.,'^(true|1)$')]
                           and ./pyde.02.01:AddressDetails.Usage.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'BUS']
                           and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] 
                           and not( ./pyde.02.08:AddressDetails.Country.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0])
                            ]
                        )" />-->
        
    <!--</rule>-->
    
</pattern>
