﻿<?xml version="1.0" encoding="utf-8"?>
<pattern id="FieldPatterns" xmlns="http://purl.oclc.org/dsdl/schematron">
    <title>Field Pattern Validations</title>

    <rule context="prsnstrcnm3.02.01:PersonNameDetails[not(@i:nil='true' or @i:nil='1')]">
        <!--    
        IF LENGTH ([TPAR91]) > 30
        RETURN VALIDATION MESSSAGE
        ENDIF

        [TPAR91] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:PersonNameDetails.FamilyName.Text WHERE (pyde.02.00:PersonNameDetails.PersonNameType.Code = "LGL" 
        AND pyde.02.05:PersonNameDetails.Usage.Code = "Identifier" 
        AND pyde.02.00:PersonNameDetails.Currency.Code = C) 
        IN TUPLE(prsnstrcnm3.02.01:PersonNameDetails)
        -->
        <assert id="VR.ATO.TPAR.000035" diagnostics="DVR.ATO.TPAR.000035"
                test="not(                  
                           pyde.02.00:PersonNameDetails.FamilyName.Text[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and string-length(normalize-space(.)) > 30]
                           and 
                           pyde.02.00:PersonNameDetails.PersonNameType.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and exslt:uppercase(.)='LGL']  
                           and
                           pyde.02.05:PersonNameDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and exslt:uppercase(.)='IDENTIFIER']                          
                           and
                           pyde.02.00:PersonNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and exslt:uppercase(.)='C']     
                        )"
                />

        <!--    
        IF LENGTH ([TPAR92]) > 15
        RETURN VALIDATION MESSSAGE
        ENDIF

        [TPAR92] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:PersonNameDetails.GivenName.Text WHERE (pyde.02.00:PersonNameDetails.PersonNameType.Code = "LGL" 
        AND pyde.02.05:PersonNameDetails.Usage.Code = "Identifier" 
        AND pyde.02.00:PersonNameDetails.Currency.Code = "C") 
        IN TUPLE(prsnstrcnm3.02.01:PersonNameDetails)
        -->
        <assert id="VR.ATO.TPAR.000036" diagnostics="DVR.ATO.TPAR.000036"
                test="not(                  
                           pyde.02.00:PersonNameDetails.GivenName.Text[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and string-length(normalize-space(.)) > 15]
                           and 
                           pyde.02.00:PersonNameDetails.PersonNameType.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and exslt:uppercase(.)='LGL']  
                           and
                           pyde.02.05:PersonNameDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and exslt:uppercase(.)='IDENTIFIER']                          
                           and
                           pyde.02.00:PersonNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and exslt:uppercase(.)='C']   
                         )"
                />
        
        <!--    
        IF LENGTH ([TPAR93]) > 15
        RETURN VALIDATION MESSSAGE
        ENDIF

        [TPAR93] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:PersonNameDetails.OtherGivenName.Text 
        WHERE (pyde.02.00:PersonNameDetails.PersonNameType.Code = "LGL" 
        AND pyde.02.05:PersonNameDetails.Usage.Code = "Identifier" 
        AND pyde.02.00:PersonNameDetails.Currency.Code = "C") 
        IN TUPLE(prsnstrcnm3.02.01:PersonNameDetails)
        -->
        <assert id="VR.ATO.TPAR.000037" diagnostics="DVR.ATO.TPAR.000037"
                test="not(                   
                           pyde.02.00:PersonNameDetails.OtherGivenName.Text[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and string-length(normalize-space(.)) > 15]
                           and 
                           pyde.02.00:PersonNameDetails.PersonNameType.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and exslt:uppercase(.)='LGL']  
                           and
                           pyde.02.05:PersonNameDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and exslt:uppercase(.)='IDENTIFIER']                          
                           and
                           pyde.02.00:PersonNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and exslt:uppercase(.)='C']      
                        )"
                />

    </rule>
    
    <rule context="orgname2.02.00:OrganisationNameDetails[not(@i:nil='true' or @i:nil='1')]">
        <!-- 
             
            IF [TPAR4] <> NULLORBLANK AND [TPAR4] DOES NOT CONTAIN SET("a-z", "A-Z")
                RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR4] = TPAR:INT:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text 
            WHERE (pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code = "MN" AND pyde.02.00:OrganisationNameDetails.Currency.Code = "C") 
            IN TUPLE(orgname2.02.00:OrganisationNameDetails) 
        -->
        <assert id="VR.ATO.TPAR.000011" diagnostics="DVR.ATO.TPAR.000011" 
                test="not(
                        pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'MN'] and 
                        pyde.02.00:OrganisationNameDetails.Currency.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] and                          
                        pyde.02.00:OrganisationNameDetails.OrganisationalName.Text[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and
                        (not(regexp:test(.,'^(.*)[a-zA-Z](.*)$')) and string-length(normalize-space(.)) != 0)]
                        )
                        "/>
        
      <!--     
           IF [TPAR4] CONTAINS SET("- -","'’","  ")
             RETURN VALIDATION MESSAGE
           ENDIF

            [TPAR4] = TPAR:INT:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text 
            WHERE (pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code = "MN" 
            AND pyde.02.00:OrganisationNameDetails.Currency.Code = "C") 
            IN TUPLE(orgname2.02.00:OrganisationNameDetails)
      -->
        
    
        <assert id="VR.ATO.TPAR.000012" diagnostics="DVR.ATO.TPAR.000012"
                test="not(
                        pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'MN'] and 
                        pyde.02.00:OrganisationNameDetails.Currency.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] and                          
                        pyde.02.00:OrganisationNameDetails.OrganisationalName.Text[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and
                        regexp:test(.,'^(.*)(--|(\x27)(\x27)|(\x20)(\x20))(.*)$')]
                       )
                        "/>
        

    </rule>
    <rule context="address2.02.02:AddressDetails[not(@i:nil='true' or @i:nil='1')]/pyde.02.00:AddressDetails.LocalityName.Text[not(@i:nil='true' or @i:nil='1')]">
        <!--  
            IF LENGTH (pyde.02.00:AddressDetails.LocalityName.Text) > 27
            RETURN VALIDATION MESSAGE 
            ENDIF 
        -->
        <assert id="VR.ATO.TPAR.000022" diagnostics="DVR.ATO.TPAR.000022"
                test="not(
                          string-length(normalize-space(.)) > 27
                        )"/>
    </rule>

    <rule context="rvctc2.02.00:IncomeTax.PayAsYouGoWithholding.TaxWithheld.Amount[not(@i:nil='true' or @i:nil='1')]">
        <!--
                
        IF [TPAR123] <> NULL AND [TPAR123] <> MONETARY (U,11,0)
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR123] = TPAR:Payee.{ABN}.{BranchCode}:rvctc2.02.00:IncomeTax.PayAsYouGoWithholding.TaxWithheld.Amount

        -->
        
        <assert id="VR.ATO.TPAR.000039" diagnostics="DVR.ATO.TPAR.000039"
                test="not(
                        @contextRef = $PAYEE.ContextId and not(regexp:test(.,'^[0-9]{1,11}$'))
                      )"/>
    </rule>

    <rule context="bafpr1.02.09:Income.BusinessPaymentGross.Amount[not(@i:nil='true' or @i:nil='1')]">
        <!--
                
        IF [TPAR122] <> NULL AND [TPAR122] <> MONETARY (U,11,0)
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR122] = TPAR:Payee.{ABN}.{BranchCode}:bafpr1.02.09:Income.BusinessPaymentGross.Amount

        -->

        <assert id="VR.ATO.TPAR.000038" diagnostics="DVR.ATO.TPAR.000038"
                test="not(
                        @contextRef = $PAYEE.ContextId and not(regexp:test(.,'^[0-9]{1,11}$'))
                      )"/>
    </rule>

    <rule context="rvctc3.02.00:GoodsAndServicesTax.Liability.Amount[not(@i:nil='true' or @i:nil='1')]">
        <!--
                
        IF [TPAR124] <> NULL AND [TPAR124] <> MONETARY (U,11,0)
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR124] = TPAR:Payee.{ABN}.{BranchCode}:rvctc3.02.00:GoodsAndServicesTax.Liability.Amount

        -->

        <assert id="VR.ATO.TPAR.000040" diagnostics="DVR.ATO.TPAR.000040"
                test="not(
                        @contextRef = $PAYEE.ContextId and not(regexp:test(.,'^[0-9]{1,11}$'))
                      )"/>
    </rule>

    <rule context="pyde.02.00:PersonUnstructuredName.FullName.Text[not(@i:nil='true' or @i:nil='1')]">
        <!--
        IF LENGTH (pyde.xx.xx:PersonUnstructuredName.FullName.Text) > 38
            RETURN VALIDATION MESSAGE
        ENDIF
        -->
        <assert id="VR.ATO.TPAR.000015" diagnostics="DVR.ATO.TPAR.000015"
                test="not(
                          string-length(normalize-space(.)) > 38
                         )"/> 
    </rule>
    
    
    <rule context="email1.02.00:ElectronicContactElectronicMail[not(@i:nil='true' or @i:nil='1')]">
        <!--
            IF [TPAR45] STARTSWITH "@" OR  [TPAR45] ENDSWITH "@"
            RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR45] = TPAR:INT:pyde.02.00:ElectronicContact.ElectronicMail.Address.Text 
            WHERE (pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code = "03") 
            IN TUPLE(email1.02.00:ElectronicContactElectronicMail)       
        -->
        <assert id="VR.ATO.TPAR.000025" diagnostics="DVR.ATO.TPAR.000025"                 
                test="not(pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and . ='03']
                         and
                         regexp:test(pyde.02.00:ElectronicContact.ElectronicMail.Address.Text
                                        [not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId],'^(?i)(@)(.*)$') 
                         or 
                         regexp:test(pyde.02.00:ElectronicContact.ElectronicMail.Address.Text
                                        [not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId],'^(.*)(?i)(@)$')
                      )"
                 />
        <!--
            IF [TPAR45] <> NULLORBLANK AND [TPAR45] DOES NOT CONTAIN "@"
             RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR45] = TPAR:INT:pyde.02.00:ElectronicContact.ElectronicMail.Address.Text 
            WHERE (pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code = "03") 
            IN TUPLE(email1.02.00:ElectronicContactElectronicMail)
               
        -->
        <assert id="VR.ATO.TPAR.000026" diagnostics="DVR.ATO.TPAR.000026"
                test="not(
                        pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and . ='03']
                        and
                        pyde.02.00:ElectronicContact.ElectronicMail.Address.Text[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and 
                        (
                        string-length(normalize-space(.)) != 0 
                        and
                        not(regexp:test(.,'^(?i)(.*)(@)(.*)$'))
                        )]
                        )" 
                />        
        <!--       
            IF [TPAR45] <> NULLORBLANK AND [TPAR45] DOES NOT CONTAIN "."
                  RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR45] = TPAR:INT:pyde.02.00:ElectronicContact.ElectronicMail.Address.Text 
            WHERE (pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code = "03") 
            IN TUPLE(email1.02.00:ElectronicContactElectronicMail)       
        -->
        <assert id="VR.ATO.TPAR.000027" diagnostics="DVR.ATO.TPAR.000027"
                test="not(
                        pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and . ='03']
                        and
                        pyde.02.00:ElectronicContact.ElectronicMail.Address.Text[not(@i:nil='true' or @i:nil='1') and @contextRef = $INT.ContextId and 
                        (
                        string-length(normalize-space(.)) != 0 
                        and
                        not(regexp:test(.,'^(?i)(.*)(\x2E)(.*)$'))
                        )]
                        )"
                />
        

    </rule>
    <rule context="pyid.02.00:Identifiers.TaxAgentNumber.Identifier[not(@i:nil='true' or @i:nil='1')]">
        <!--
          IF [TPAR131] <> NULL AND (TANALGORITHM [TPAR131]= FALSE)
             RETURN VALIDATION MESSAGE
          ENDIF 
          [TPAR131] = TPAR:INT:pyid.02.00:Identifiers.TaxAgentNumber.Identifier
        -->
        <assert id="VR.ATO.TPAR.000045" diagnostics="DVR.ATO.TPAR.000045"
                
                test="not(
                             @contextRef =  $INT.ContextId and not(function:ValidateTAN(.))
                           )" />
               
    </rule>

</pattern>
