﻿<?xml version="1.0" encoding="utf-8"?>
<pattern id="Mandatories" xmlns="http://purl.oclc.org/dsdl/schematron">
    <title>Mandatory Validations</title>
    
    <rule context="xbrli:xbrl[not(@i:nil='true' or @i:nil='1')]/xbrli:context[not(@i:nil='true' or @i:nil='1')]">

        <let name="CurrentRPContextId" value="./@id" />
        
        <!-- 
        FOR ANY OCCURRENCE OF CONTEXT (RP)
        IF [TPAR51] = NULLORBLANK
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR51] = TPAR:RP:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text 
        WHERE (pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code = "MN" 
        AND pyde.02.00:OrganisationNameDetails.Currency.Code = "C") 
        IN TUPLE(orgname2.02.00:OrganisationNameDetails)
        -->

        <assert id="VR.ATO.TPAR.000032" diagnostics="DVR.ATO.TPAR.000032"
                test="not(
                        . = $RP.Context and
                      count(  ../orgname2.02.00:OrganisationNameDetails
                        [
                            not(@i:nil='true' or @i:nil='1')
                        and ./pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'MN']
                        and ./pyde.02.00:OrganisationNameDetails.Currency.Code[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                        and ./pyde.02.00:OrganisationNameDetails.OrganisationalName.Text[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0]
                        ]  
                     ) &lt; 1
                     )"
                 />

        <!-- 
       
        FOR ANY OCCURRENCE OF CONTEXT (RP)
        IF [TPAR60] = NULLORBLANK 
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR60] = TPAR:RP:pyde.02.00:AddressDetails.Line1.Text 
        WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") 
        IN TUPLE(address2.02.02:AddressDetails)
        -->
        <assert id="VR.ATO.TPAR.000033" diagnostics="DVR.ATO.TPAR.000033"
                test="not(
                        . = $RP.Context and
                        count(../address2.02.02:AddressDetails
                            [
                             not(@i:nil='true' or @i:nil='1')
                            and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                            and ./pyde.02.00:AddressDetails.Line1.Text[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0]
                            ]
                        )&lt; 1
                     )" />

      
        <!-- 
        FOR ANY OCCURRENCE OF CONTEXT (RP)
        IF [TPAR47] = NULL
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR47] = TPAR:RP:pyin.02.00:Report.TargetFinancial.Year
        -->
        <assert id="VR.ATO.TPAR.000028" diagnostics="DVR.ATO.TPAR.000028"
                test="not(
                        . = $RP.Context and
                        not(../pyin.02.00:Report.TargetFinancial.Year[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                     )"
                 />


        <let name="CurrentPayeeContextId" value="./@id" />

        <!-- 
        FOR ANY OCCURRENCE OF CONTEXT (Payee.{ABN}.{BranchCode})
        IF [TPAR125] = NULL
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR125] = TPAR:Payee.{ABN}.{BranchCode}:pyin.02.07:Report.Amendment.Indicator
        -->
        <assert id="VR.ATO.TPAR.000041" diagnostics="DVR.ATO.TPAR.000041"
                test="not(
                        . = $PAYEE.Context and
                        not(../pyin.02.07:Report.Amendment.Indicator[@contextRef = $CurrentPayeeContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                     )"
                 />

        
    </rule>
        
    <rule context="xbrli:xbrl[not(@i:nil='true' or @i:nil='1')]">

        <!-- 
        IF [TPAR4] = NULLORBLANK
            RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR4] = TPAR:INT:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text 
        WHERE (pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code = "MN" AND pyde.02.00:OrganisationNameDetails.Currency.Code = "C") 
        IN TUPLE(orgname2.02.00:OrganisationNameDetails)
        -->
        <assert  id="VR.ATO.TPAR.000010" diagnostics="DVR.ATO.TPAR.000010"
                 test="not(
                            count(orgname2.02.00:OrganisationNameDetails[
                            not(@i:nil='true' or @i:nil='1')
                            and ./pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'MN']
                            and ./pyde.02.00:OrganisationNameDetails.Currency.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']                           
                            and ./pyde.02.00:OrganisationNameDetails.OrganisationalName.Text[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') 
                            and string-length(normalize-space(.)) != 0]
                            ]) &lt;1
                          )" />
        
        <!-- 
        IF [TPAR9] = NULLORBLANK
            RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR9] = TPAR:INT:pyde.02.00:ElectronicContact.Telephone.Minimal.Number 
                    WHERE (pyde.02.00:ElectronicContact.Telephone.Usage.Code = "03")
                                    IN TUPLE(phone1.02.00:ElectronicContactTelephone)
        -->
        <assert  id="VR.ATO.TPAR.000013" diagnostics="DVR.ATO.TPAR.000013"
                 test="not(
                           count( phone1.02.00:ElectronicContactTelephone[
                            not(@i:nil='true' or @i:nil='1') 
                            and ./pyde.02.00:ElectronicContact.Telephone.Usage.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and . = '03'] 
                            and ./pyde.02.00:ElectronicContact.Telephone.Minimal.Number[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0] 
                            ] ) &lt;1
                            )" />

        <!--
   
            IF [TPAR12] = NULLORBLANK 
                RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR12] = TPAR:INT:pyde.02.00:PersonUnstructuredName.FullName.Text 
            WHERE (pyde.02.05:PersonUnstructuredName.Usage.Code = "Contact") 
            IN TUPLE(prsnunstrcnm1.02.01:PersonUnstructuredName)

        -->
        <assert id="VR.ATO.TPAR.000016"  diagnostics="DVR.ATO.TPAR.000016"
                test="not(
                           count( prsnunstrcnm1.02.01:PersonUnstructuredName[
                            not(@i:nil='true' or @i:nil='1') 
                            and ./pyde.02.05:PersonUnstructuredName.Usage.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'CONTACT']
                            and ./pyde.02.00:PersonUnstructuredName.FullName.Text[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0] 
                            ]) &lt; 1
                            
                        )" />
        <!--
            IF [TPAR21] = NULLORBLANK 
            RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR21] = TPAR:INT:pyde.02.00:AddressDetails.Line1.Text 
            WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" AND pyde.02.00:AddressDetails.Currency.Code = "C") 
            IN TUPLE(address2.02.02:AddressDetails)      
        -->
        <assert  id="VR.ATO.TPAR.000020" diagnostics="DVR.ATO.TPAR.000020"
             test="not(
                           count( address2.02.02:AddressDetails[
                            not(@i:nil='true' or @i:nil='1')
                            and ./pyde.02.01:AddressDetails.Usage.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'BUS']
                            and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']                           
                            and ./pyde.02.00:AddressDetails.Line1.Text[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') 
                            and string-length(normalize-space(.)) != 0]
                            ]) &lt;1
                          )" />    
    
        <!--
            IF [TPAR25] = NULLORBLANK
              RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR25] = TPAR:INT:pyde.02.00:AddressDetails.LocalityName.Text 
            WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" AND pyde.02.00:AddressDetails.Currency.Code = "C") 
            IN TUPLE(address2.02.02:AddressDetails)        
        
        -->
        <assert  id="VR.ATO.TPAR.000021" diagnostics="DVR.ATO.TPAR.000021" 
                 test="not(
                           count(address2.02.02:AddressDetails[
                            not(@i:nil='true' or @i:nil='1')
                            and ./pyde.02.01:AddressDetails.Usage.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'BUS']
                            and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']                           
                            and ./pyde.02.00:AddressDetails.LocalityName.Text[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') 
                            and string-length(normalize-space(.)) != 0]
                            ] )&lt;1
                          )" />
        <!--
            IF [TPAR128] = NULL
              RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR128] = TPAR:INT:pyin.02.00:Declaration.StatementAccepted.Indicator 
            WHERE (pyin.02.03:Declaration.StatementType.Code = "TrueAndCorrect") 
            IN TUPLE(declaration1.02.01:Declaration)
        
        -->

        <assert id="VR.ATO.TPAR.000043"  diagnostics="DVR.ATO.TPAR.000043"
                test="not(
                          declaration1.02.01:Declaration[
                          not(@i:nil='true' or @i:nil='1') 
                          and ./pyin.02.03:Declaration.StatementType.Code[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'TRUEANDCORRECT']
                          and not(./pyin.02.00:Declaration.StatementAccepted.Indicator[@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1')])
                          ]
                      )" />


     
    </rule>

</pattern>
