﻿<?xml version="1.0" encoding="utf-8"?>
<pattern id="Warnings" xmlns="http://purl.oclc.org/dsdl/schematron">
    <title>Warning Validations</title>
 
   <rule context="pyde.02.00:AddressDetails.Line3.Text[not(@i:nil='true' or @i:nil='1')]"> 
        <!--
        IF (pyde.xx.xx:AddressDetails.Line3.Text <> NULLORBLANK) 
            RETURN VALIDATION MESSAGE
        ENDIF
        -->
        <assert id="VR.ATO.TPAR.W00002" diagnostics="DVR.ATO.TPAR.W00002"
                test="not(
                            string-length(normalize-space(.)) != 0
                        )" />
    </rule>

    <rule context="pyde.02.00:AddressDetails.Line4.Text[not(@i:nil='true' or @i:nil='1')]">
        <!--
        IF (pyde.xx.xx:AddressDetails.Line4.Text <> NULLORBLANK) 
            RETURN VALIDATION MESSAGE
        ENDIF
        -->
        <assert id="VR.ATO.TPAR.W00003" diagnostics="DVR.ATO.TPAR.W00003"
                test="not(
                            string-length(normalize-space(.)) != 0
                        )" />
    </rule>
    

    <rule context="pyde.02.08:AddressDetails.CountryName.Text[not(@i:nil='true' or @i:nil='1')]">
        <!--
        IF (pyde.xx.xx:AddressDetails.CountryName.Text <> NULLORBLANK)
            RETURN VALIDATION MESSAGE
        ENDIF
        -->
        <assert id="VR.ATO.TPAR.W00004" diagnostics="DVR.ATO.TPAR.W00004"
                test="not(
                            string-length(normalize-space(.)) != 0
                        )" />
    </rule>




    <rule context="address2.02.02:AddressDetails[not(@i:nil='true' or @i:nil='1')]">

        <!--
        WHERE IN TUPLE(addressdetails2.xx.xx:AddressDetails)
        IF (pyde.xx.xx:AddressDetails.Country.Code = "au") AND  (pyde.xx.xx:AddressDetails.OverseasAddress.Indicator = TRUE)   
           RETURN VALIDATION MESSAGE
        ENDIF
        -->
        <assert id="VR.ATO.TPAR.W00001" diagnostics="DVR.ATO.TPAR.W00001"
                test="not(
                           pyde.02.08:AddressDetails.Country.Code[not(@i:nil='true' or @i:nil='1') and normalize-space(exslt:uppercase(.))='AU']  
                           and pyde.02.00:AddressDetails.OverseasAddress.Indicator[not(@i:nil='true' or @i:nil='1') and regexp:test(exslt:uppercase(.),'^(TRUE|1)$')]
                        )" />


        <!--WHERE IN TUPLE(addressdetails2.xx.xx:AddressDetails)
        IF (pyde.xx.xx:AddressDetails.Country.Code <> NULLORBLANK) AND (pyde.xx.xx:AddressDetails.Country.Code <> "au") AND  (pyde.xx.xx:AddressDetails.OverseasAddress.Indicator = FALSE)
        RETURN VALIDATION MESSAGE
        ENDIF-->
        <assert id="VR.ATO.TPAR.W00005" diagnostics="DVR.ATO.TPAR.W00005"
                test="not(
                           pyde.02.08:AddressDetails.Country.Code[not(@i:nil='true' or @i:nil='1') and  string-length(normalize-space(.)) != 0 and normalize-space(exslt:uppercase(.)) !='AU']  
                           and pyde.02.00:AddressDetails.OverseasAddress.Indicator[not(@i:nil='true' or @i:nil='1') and regexp:test(exslt:uppercase(.),'^(FALSE|0)$')]
                        )" />


        <!--
        IF [TPAR112] <> NULL AND [TPAR112] <> SET ("ACT","NSW","NT","QLD","SA","VIC","WA","TAS")
            RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR112] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:AddressDetails.StateOrTerritory.Code 
        WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") 
        IN TUPLE(address2.02.02:AddressDetails)
        -->

        <assert id="VR.ATO.GEN.W00027" diagnostics="DVR.ATO.TPAR.W00027"
                test="not(pyde.02.00:AddressDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and  (@contextRef = $PAYEE.ContextId) and exslt:uppercase(.)='C']
                        and
                        pyde.02.00:AddressDetails.StateOrTerritory.Code[not(@i:nil='true' or @i:nil='1') and (@contextRef = $PAYEE.ContextId)
                        and
                        not(regexp:test(exslt:uppercase(normalize-space(.)),'^(?i)(ACT|NSW|NT|QLD|SA|VIC|WA|TAS)$'))]
                        )" 
                
             />
        
        <!--
        
             
        IF [TPAR66] <> NULL AND [TPAR66] <> SET ("ACT","NSW","NT","QLD","SA","VIC","WA","TAS")
         RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR66] = TPAR:RP:pyde.02.00:AddressDetails.StateOrTerritory.Code WHERE 
        (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)

        -->

        <assert id="VR.ATO.GEN.W00010" diagnostics="DVR.ATO.TPAR.W00010"
                test="not(
                          pyde.02.00:AddressDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and  (@contextRef = $RP.ContextId) and exslt:uppercase(.)='C']
                        and
                          pyde.02.00:AddressDetails.StateOrTerritory.Code[not(@i:nil='true' or @i:nil='1') and (@contextRef = $RP.ContextId)
                        and
                          not(regexp:test(exslt:uppercase(normalize-space(.)),'^(?i)(\s+|^)(ACT|NSW|NT|QLD|SA|VIC|WA|TAS)(\s+|$)'))]                           
                        )"
                
             />

    </rule>

    <rule context="orgname2.02.00:OrganisationNameDetails[not(@i:nil='true' or @i:nil='1')]">
        <!--         
         IF [TPAR51] <> NULLORBLANK AND [TPAR51] DOES NOT CONTAIN SET("a-z", "A-Z")
           RETURN VALIDATION MESSAGE
         ENDIF

        [TPAR51] = TPAR:RP:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text 
        WHERE (pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code = "MN" AND pyde.02.00:OrganisationNameDetails.Currency.Code = "C") 
        IN TUPLE(orgname2.02.00:OrganisationNameDetails)         
        -->
        <assert id="VR.ATO.TPAR.W00006" diagnostics="DVR.ATO.TPAR.W00006"
                test="not(
                        pyde.02.00:OrganisationNameDetails.OrganisationalName.Text[ not(@i:nil='true' or @i:nil='1') and @contextRef = $RP.ContextId and (string-length(normalize-space(.)) != 0) and not(regexp:test(.,'^(.*)[a-zA-Z](.*)$')) ]
                        and pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'MN']
                        and pyde.02.00:OrganisationNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                    )"/>
        
        
        
        <!--
        
        IF [TPAR55] <> NULLORBLANK AND [TPAR55] DOES NOT CONTAIN SET("a-z", "A-Z")
             RETURN VALIDATION MESSAGE
        ENDIF

            [TPAR55] = TPAR:RP:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text 
            WHERE (pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code = "MTR" AND 
            pyde.02.00:OrganisationNameDetails.Currency.Code = "C") 
            IN TUPLE(orgname2.02.00:OrganisationNameDetails)
        -->
        <assert id="VR.ATO.TPAR.W00007" diagnostics="DVR.ATO.TPAR.W00007"
                test="not(
                        pyde.02.00:OrganisationNameDetails.OrganisationalName.Text[ not(@i:nil='true' or @i:nil='1') and @contextRef = $RP.ContextId and string-length(normalize-space(.)) != 0 and not(regexp:test(.,'^(.*)[a-zA-Z](.*)$')) ]
                        and pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'MTR']
                        and pyde.02.00:OrganisationNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                    )"/>

        
        <!--
            IF [TPAR97] <> NULLORBLANK AND [TPAR97] DOES NOT CONTAIN SET("a-z", "A-Z")
               RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR97] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text 
            WHERE (pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code = "MN" 
            AND pyde.02.00:OrganisationNameDetails.Currency.Code = "C") 
            IN TUPLE(orgname2.02.00:OrganisationNameDetails)
        -->
        <assert id="VR.ATO.TPAR.W00023" diagnostics="DVR.ATO.TPAR.W00023"
                test="not(
                        pyde.02.00:OrganisationNameDetails.OrganisationalName.Text[ not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and string-length(normalize-space(.)) != 0 and not(regexp:test(.,'^(.*)[a-zA-Z](.*)$')) ]
                        and pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'MN']
                        and pyde.02.00:OrganisationNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                    )"/>




    </rule>

    <rule context="xbrli:xbrl[not(@i:nil='true' or @i:nil='1')]/xbrli:context[not(@i:nil='true' or @i:nil='1')]">

        <let name="CurrentRPContextId" value="./@id" />
       

        <!--
            FOR ANY OCCURRENCE OF CONTEXT (RP)
            IF [TPAR57] = FALSE AND ([TPAR65] = NULL OR [TPAR66] = NULL)
            RETURN VALIDATION MESSAGE
            ENDIF

            [TPAR57] = TPAR:RP:pyde.02.00:AddressDetails.OverseasAddress.Indicator 
                    WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
            [TPAR65] = TPAR:RP:pyde.02.00:AddressDetails.Postcode.Text 
                    WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
            [TPAR66] = TPAR:RP:pyde.02.00:AddressDetails.StateOrTerritory.Code 
                    WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
          -->
        
        <assert id="VR.ATO.TPAR.W00008" diagnostics="DVR.ATO.TPAR.W00008"
                test="not(
                           . = $RP.Context and
                            ../address2.02.02:AddressDetails[
                              not(@i:nil='true' or @i:nil='1') 
                              and ./pyde.02.00:AddressDetails.OverseasAddress.Indicator[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and regexp:test(exslt:uppercase(.),'^(FALSE|0)$')]
                              and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] 
                              and (
                                not(./pyde.02.00:AddressDetails.Postcode.Text[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                                or
                                not(./pyde.02.00:AddressDetails.StateOrTerritory.Code[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                                )
                             ]
                        )" />   
      
        <!--
                       
         FOR ANY OCCURRENCE OF CONTEXT (RP)
        IF [TPAR57] = TRUE AND [TPAR68] = NULL
          RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR57] = TPAR:RP:pyde.02.00:AddressDetails.OverseasAddress.Indicator WHERE
        (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
        [TPAR68] = TPAR:RP:pyde.02.08:AddressDetails.Country.Code WHERE 
        (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)   
        -->

        <assert id="VR.ATO.TPAR.W00011" diagnostics="DVR.ATO.TPAR.W00011"
                test="not(
                           . = $RP.Context and
                           ../address2.02.02:AddressDetails[
                           not(@i:nil='true' or @i:nil='1') and
                           ./pyde.02.00:AddressDetails.OverseasAddress.Indicator[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and regexp:test(.,'^(true|1)$')]
                           and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] 
                           and not( ./pyde.02.08:AddressDetails.Country.Code[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0])
                            ]
                        )" />


        <!--
        FOR ANY OCCURRENCE OF CONTEXT (RP)
        IF [TPAR71] = NULLORBLANK
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR71] = TPAR:RP:pyde.02.00:PersonUnstructuredName.FullName.Text 
        WHERE (pyde.02.05:PersonUnstructuredName.Usage.Code = "Contact") 
        IN TUPLE(prsnunstrcnm1.02.01:PersonUnstructuredName)
        -->

        <assert id="VR.ATO.TPAR.W00012" diagnostics="DVR.ATO.TPAR.W00012"
                test="not(
                           . = $RP.Context and
                           ../prsnunstrcnm1.02.01:PersonUnstructuredName[
                           not(@i:nil='true' or @i:nil='1') and
                           not( ./pyde.02.00:PersonUnstructuredName.FullName.Text[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0])
                            and ./pyde.02.05:PersonUnstructuredName.Usage.Code[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'CONTACT']
                            ]
                        )" />

        <!--
        FOR ANY OCCURRENCE OF CONTEXT (Payee.{ABN}.{BranchCode})
        IF [TPAR122] = NULL
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR122] = TPAR:Payee.{ABN}.{BranchCode}:bafpr1.02.09:Income.BusinessPaymentGross.Amount
        -->

        <let name="CurrentPAYEEContextId" value="./@id" />
        
        <assert id="VR.ATO.TPAR.W00030" diagnostics="DVR.ATO.TPAR.W00030"
               test="not(
                        . = $PAYEE.Context and
                        not(../bafpr1.02.09:Income.BusinessPaymentGross.Amount[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                     )"
                 />

        <!-- 
        FOR ANY OCCURRENCE OF CONTEXT (RP)
        IF [TPAR64] = NULLORBLANK
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR64] = TPAR:RP:pyde.02.00:AddressDetails.LocalityName.Text 
        WHERE (pyde.02.01:AddressDetails.Usage.Code = "BUS" 
        AND pyde.02.00:AddressDetails.Currency.Code = "C") 
        IN TUPLE(address2.02.02:AddressDetails)
        
        FOR ANY OCCURRENCE OF CONTEXT (RP)
        IF [TPAR64] = NULLORBLANK
          RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR64] = TPAR:RP:pyde.02.00:AddressDetails.LocalityName.Text 
        WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") 
        IN TUPLE(address2.02.02:AddressDetails)

        -->
        <assert id="VR.ATO.TPAR.W00009" diagnostics="DVR.ATO.TPAR.W00009"
                test="not(
                        . = $RP.Context and
                         ../address2.02.02:AddressDetails[
                         not(@i:nil='true' or @i:nil='1')                        
                         and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] 
                         and not(./pyde.02.00:AddressDetails.LocalityName.Text[@contextRef = $CurrentRPContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                    ]    
                )"
                 />
        <!-- 
        FOR ANY OCCURRENCE OF CONTEXT (Payee.{ABN}.{BranchCode})
        IF [TPAR123] <> NULL AND [TPAR123] > [TPAR122]
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR122] = TPAR:Payee.{ABN}.{BranchCode}:bafpr1.02.09:Income.BusinessPaymentGross.Amount
        [TPAR123] = TPAR:Payee.{ABN}.{BranchCode}:rvctc2.02.00:IncomeTax.PayAsYouGoWithholding.TaxWithheld.Amount
        -->
        <assert id="VR.ATO.TPAR.W00031" diagnostics="DVR.ATO.TPAR.W00031"
                test="not(
                        . = $PAYEE.Context 
                         and ../rvctc2.02.00:IncomeTax.PayAsYouGoWithholding.TaxWithheld.Amount[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0]
                         and 
                         (../rvctc2.02.00:IncomeTax.PayAsYouGoWithholding.TaxWithheld.Amount[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1')]  &gt; 
                          ../bafpr1.02.09:Income.BusinessPaymentGross.Amount[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1')] 
                          )
                )"
                 />

        <!-- 
        FOR ANY OCCURRENCE OF CONTEXT (Payee.{ABN}.{BranchCode})
        IF [TPAR124] <> NULL AND [TPAR124] > [TPAR122]
        RETURN VALIDATION MESSAGE
        END IF


        [TPAR122] = TPAR:Payee.{ABN}.{BranchCode}:bafpr1.02.09:Income.BusinessPaymentGross.Amount
        [TPAR124] = TPAR:Payee.{ABN}.{BranchCode}:rvctc3.02.00:GoodsAndServicesTax.Liability.Amount
        -->
        <assert id="VR.ATO.TPAR.W00032" diagnostics="DVR.ATO.TPAR.W00032"
                test="not(
                        . = $PAYEE.Context 
                         and ../rvctc3.02.00:GoodsAndServicesTax.Liability.Amount[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0]
                         and 
                         (../rvctc3.02.00:GoodsAndServicesTax.Liability.Amount[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1')]  &gt; 
                          ../bafpr1.02.09:Income.BusinessPaymentGross.Amount[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1')] 
                          )
                )"
                 />
        
        <!-- 
        FOR ANY OCCURRENCE OF CONTEXT (Payee.{ABN}.{BranchCode})
        IF [TPAR103]= FALSE AND ([TPAR111] = NULL OR [TPAR112] = NULL)
           RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR103] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:AddressDetails.OverseasAddress.Indicator 
        WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
        [TPAR111] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:AddressDetails.Postcode.Text 
        WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
        [TPAR112] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:AddressDetails.StateOrTerritory.Code 
        WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
        -->
        <assert id="VR.ATO.TPAR.W00025" diagnostics="DVR.ATO.TPAR.W00025"
                test="not(
                        . = $PAYEE.Context and
                         ../address2.02.02:AddressDetails[
                         not(@i:nil='true' or @i:nil='1') 
                         and ./pyde.02.00:AddressDetails.OverseasAddress.Indicator[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and regexp:test(.,'^(false|0)$')]
                         and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] 
                         and (
                            not(./pyde.02.00:AddressDetails.Postcode.Text[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                            or
                            not(./pyde.02.00:AddressDetails.StateOrTerritory.Code[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                            )
                    ]
                )"
                 />

        <!-- 
        FOR ANY OCCURRENCE OF CONTEXT (Payee.{ABN}.{BranchCode})
        IF [TPAR103] = TRUE AND [TPAR114] = NULL
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR103] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:AddressDetails.OverseasAddress.Indicator 
        WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
        [TPAR114] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.08:AddressDetails.Country.Code 
        WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") IN TUPLE(address2.02.02:AddressDetails)
        -->
        <assert id="VR.ATO.TPAR.W00028" diagnostics="DVR.ATO.TPAR.W00028"
                test="not(
                        . = $PAYEE.Context and
                         ../address2.02.02:AddressDetails[
                         not(@i:nil='true' or @i:nil='1') 
                         and ./pyde.02.00:AddressDetails.OverseasAddress.Indicator[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and regexp:test(.,'^(true|1)$')]
                         and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] 
                         and not(./pyde.02.08:AddressDetails.Country.Code[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                    ]    
                )"
                 />

        <!-- 
        FOR ANY OCCURRENCE OF CONTEXT (Payee.{ABN}.{BranchCode})
        IF [TPAR91] = NULLORBLANK AND [TPAR97] = NULLORBLANK
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR91] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:PersonNameDetails.FamilyName.Text 
        WHERE (pyde.02.00:PersonNameDetails.PersonNameType.Code = "LGL" 
        AND pyde.02.05:PersonNameDetails.Usage.Code = "Identifier" 
        AND pyde.02.00:PersonNameDetails.Currency.Code = "C") IN TUPLE(prsnstrcnm3.02.01:PersonNameDetails)
        [TPAR97] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text 
        WHERE (pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code = "MN" 
        AND pyde.02.00:OrganisationNameDetails.Currency.Code = "C") IN TUPLE(orgname2.02.00:OrganisationNameDetails)
        
        -->

        <assert id="CMN.ATO.TPAR.W00022" diagnostics="DVR.ATO.TPAR.W00022"
                test="not(
                        . = $PAYEE.Context and
                        ../orgname2.02.00:OrganisationNameDetails
                        [
                            not(@i:nil='true' or @i:nil='1')
                        and ./pyde.02.00:OrganisationNameDetails.OrganisationalNameType.Code[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'MN']
                        and ./pyde.02.00:OrganisationNameDetails.Currency.Code[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                        and not(./pyde.02.00:OrganisationNameDetails.OrganisationalName.Text[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0])
                        ]
                        and
                        ../prsnstrcnm3.02.01:PersonNameDetails
                        [
                            not(@i:nil='true' or @i:nil='1')
                        and ./pyde.02.00:PersonNameDetails.PersonNameType.Code[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'LGL']
                        and ./pyde.02.05:PersonNameDetails.Usage.Code[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'IDENTIFIER']
                        and not(./pyde.02.00:PersonNameDetails.FamilyName.Text[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.)) != 0])
                        ]
                     )"
                 />

        <!--
        FOR ANY OCCURRENCE OF CONTEXT (Payee.{ABN}.{BranchCode})
        IF [TPAR110] = NULLORBLANK
        RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR110] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:AddressDetails.LocalityName.Text 
        WHERE (pyde.02.00:AddressDetails.Currency.Code = "C") 
        IN TUPLE(address2.02.02:AddressDetails)
        -->

        <assert id="VR.ATO.TPAR.W00026" diagnostics="DVR.ATO.TPAR.W00026"
               test="not(
                        . = $PAYEE.Context and
                        ../address2.02.02:AddressDetails[
                        not(@i:nil='true' or @i:nil='1') 
                        and ./pyde.02.00:AddressDetails.Currency.Code[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C'] 
                        and not(./pyde.02.00:AddressDetails.LocalityName.Text[@contextRef = $CurrentPAYEEContextId and not(@i:nil='true' or @i:nil='1') and string-length(normalize-space(.))  != 0])
                        ]   
                    )"
                 />
        
    </rule>

    <rule context="email1.02.00:ElectronicContactElectronicMail[not(@i:nil='true' or @i:nil='1')]">
        <!--   
        IF [TPAR83] STARTSWITH "@" OR  [TPAR83] ENDSWITH "@"
          RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR83] = TPAR:RP:pyde.02.00:ElectronicContact.ElectronicMail.Address.Text 
        WHERE (pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code = "03") 
        IN TUPLE(email1.02.00:ElectronicContactElectronicMail)
        -->

        <assert id="VR.ATO.TPAR.W00013" diagnostics="DVR.ATO.TPAR.W00013"
                test="not(pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $RP.ContextId and . ='03']
                         and
                         regexp:test(pyde.02.00:ElectronicContact.ElectronicMail.Address.Text
                                        [not(@i:nil='true' or @i:nil='1') and @contextRef = $RP.ContextId],'^(?i)(@)(.*)$') 
                         or 
                         regexp:test(pyde.02.00:ElectronicContact.ElectronicMail.Address.Text
                                        [not(@i:nil='true' or @i:nil='1') and @contextRef = $RP.ContextId],'^(.*)(?i)(@)$')
                      )"
                 />

        <!--        
         IF [TPAR83] <> NULLORBLANK AND [TPAR83] DOES NOT CONTAIN "."
              RETURN VALIDATION MESSAGE
         ENDIF

        [TPAR83] = TPAR:RP:pyde.02.00:ElectronicContact.ElectronicMail.Address.Text 
        WHERE (pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code = "03") 
        IN TUPLE(email1.02.00:ElectronicContactElectronicMail)       
        
        -->
        <assert id="VR.ATO.TPAR.W00015" diagnostics="DVR.ATO.TPAR.W00015"
                test="not(
                         pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $RP.ContextId and . ='03']
                         and
                         pyde.02.00:ElectronicContact.ElectronicMail.Address.Text[not(@i:nil='true' or @i:nil='1') and @contextRef = $RP.ContextId and not(regexp:test(.,'^(?i)(.*)(\x2E)(.*)$'))]
                      )"
                 />
        
        <!--
        
        IF [TPAR83] <> NULLORBLANK AND [TPAR83] DOES NOT CONTAIN "@"
              RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR83] = TPAR:RP:pyde.02.00:ElectronicContact.ElectronicMail.Address.Text 
        WHERE (pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code = "03") 
        IN TUPLE(email1.02.00:ElectronicContactElectronicMail) 
        
        -->
        <assert id="VR.ATO.TPAR.W00014" diagnostics="DVR.ATO.TPAR.W00014"
                test="not(
                         pyde.02.00:ElectronicContact.ElectronicMail.Usage.Code[not(@i:nil='true' or @i:nil='1') and @contextRef = $RP.ContextId and . ='03']
                         and
                         pyde.02.00:ElectronicContact.ElectronicMail.Address.Text[not(@i:nil='true' or @i:nil='1') and @contextRef = $RP.ContextId and not(regexp:test(.,'^(?i)(.*)(@)(.*)$'))]
                      )"
                 />
        
    </rule>

    <rule context="pyid.02.00:FinancialInstitutionAccount.BankStateBranch.Number[not(@i:nil='true' or @i:nil='1')]">
        <!--
            IF pyid.xx.xx:FinancialInstitutionAccount.BankStateBranch.Number <> NULLORBLANK 
            AND (pyid.xx.xx:FinancialInstitutionAccount.BankStateBranch.Number <> SET(012001- 999999)) 
            OR (LENGTH(pyid.xx.xx:FinancialInstitutionAccount.BankStateBranch.Number) <> 6)
                RETURN VALIDATION MESSAGE
           ENDIF
        -->

        <assert id="VR.ATO.TPAR.W00029" diagnostics="DVR.ATO.TPAR.W00029"
                test="not(
                          (string-length(normalize-space(.)) != 0)
                          and (not(regexp:test(., '^(0[1-9][2-9][0-9][0-9][1-9]|[1-9][0-9][0-9][0-9][0-9][0-9])$'))
                          or (string-length(normalize-space(.)) != 6))
                          )"/>
    </rule> 
    

    <rule context="pyid.02.00:Identifiers.AustralianBusinessNumber.Identifier[not(@i:nil='true' or @i:nil='1')]">
        <!-- 
        
        IF ([TPAR84] <> NULLORBLANK) and (ABNALGORITHM([TPAR84]) = FALSE)
            RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR84] = TPAR:Payee.{ABN}.{BranchCode}:pyid.02.00:Identifiers.AustralianBusinessNumber.Identifier

        -->

        <assert id="VR.ATO.TPAR.W00016" diagnostics="DVR.ATO.TPAR.W00016"
                test="@contextRef = $PAYEE.ContextId and (string-length(normalize-space(.)) != 0) and function:ValidateABN(.)"                
                />
   
    </rule>
  
    <rule context="prsnstrcnm3.02.01:PersonNameDetails[not(@i:nil='true' or @i:nil='1')]">
        <!--
    
        IF [TPAR92] <> NULLORBLANK AND [TPAR92] DOES NOT CONTAIN SET("A-Z","a-z")
            RETURN VALIDATION MESSSAGE
        ENDIF

        [TPAR92] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:PersonNameDetails.GivenName.Text 
            WHERE (pyde.02.00:PersonNameDetails.PersonNameType.Code = "LGL" AND pyde.02.05:PersonNameDetails.Usage.Code = "Identifier" 
            AND pyde.02.00:PersonNameDetails.Currency.Code = "C") 
            IN TUPLE(prsnstrcnm3.02.01:PersonNameDetails)
        -->
        <assert id="VR.ATO.TPAR.W00020" diagnostics="DVR.ATO.TPAR.W00020"
                test="not(
                        pyde.02.00:PersonNameDetails.GivenName.Text[ not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and string-length(normalize-space(.)) != 0 and not(regexp:test(.,'^(.*)[a-zA-Z](.*)$')) ]
                        and pyde.02.00:PersonNameDetails.PersonNameType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'LGL']
                        and pyde.02.05:PersonNameDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'IDENTIFIER']
                        and pyde.02.00:PersonNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                       
                        )"
                />
        
        <!--
        IF [TPAR91] <> NULLORBLANK AND [TPAR91] DOES NOT CONTAIN SET("A-Z","a-z")
           RETURN VALIDATION MESSSAGE
        ENDIF

        [TPAR91] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:PersonNameDetails.FamilyName.Text 
        WHERE (pyde.02.00:PersonNameDetails.PersonNameType.Code = "LGL" 
        AND pyde.02.05:PersonNameDetails.Usage.Code = "Identifier" 
        AND pyde.02.00:PersonNameDetails.Currency.Code = "C") 
        IN TUPLE(prsnstrcnm3.02.01:PersonNameDetails)
        -->
        <assert id="VR.ATO.TPAR.W00019" diagnostics="DVR.ATO.TPAR.W00019"
                test="not(
                        pyde.02.00:PersonNameDetails.FamilyName.Text[ not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and string-length(normalize-space(.)) != 0 and not(regexp:test(.,'^(.*)[a-zA-Z](.*)$')) ]
                        and pyde.02.00:PersonNameDetails.PersonNameType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'LGL']
                        and pyde.02.05:PersonNameDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'IDENTIFIER']
                        and pyde.02.00:PersonNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                       
                        )"
                />
        
        <!--
        IF [TPAR93] <> NULLORBLANK AND [TPAR93] DOES NOT CONTAIN SET("A-Z","a-z")
           RETURN VALIDATION MESSSAGE
        ENDIF

        [TPAR93] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:PersonNameDetails.OtherGivenName.Text 
                    WHERE (pyde.02.00:PersonNameDetails.PersonNameType.Code = "LGL" 
                    AND pyde.02.05:PersonNameDetails.Usage.Code = "Identifier" 
                    AND pyde.02.00:PersonNameDetails.Currency.Code = "C") 
                    IN TUPLE(prsnstrcnm3.02.01:PersonNameDetails)        
        -->
        <assert id="VR.ATO.TPAR.W00021" diagnostics="DVR.ATO.TPAR.W00021"
                 test="not(
                        pyde.02.00:PersonNameDetails.OtherGivenName.Text[ not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and string-length(normalize-space(.)) != 0 and not(regexp:test(.,'^(.*)[a-zA-Z](.*)$')) ]
                        and pyde.02.00:PersonNameDetails.PersonNameType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'LGL']
                        and pyde.02.05:PersonNameDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'IDENTIFIER']
                        and pyde.02.00:PersonNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                       
                        )"
                />
        
        <!--
 
        IF [TPAR89] <> NULLORBLANK  AND [TPAR89] <> SET(DOMAIN(TITLE CODES))
            RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR89] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:PersonNameDetails.Title.Text 
        WHERE (pyde.02.00:PersonNameDetails.PersonNameType.Code = "LGL" AND 
        pyde.02.05:PersonNameDetails.Usage.Code = "Identifier" AND 
        pyde.02.00:PersonNameDetails.Currency.Code = "C") 
        IN TUPLE(prsnstrcnm3.02.01:PersonNameDetails)
         
        -->

        <assert id="VR.ATO.TPAR.W00017" diagnostics="DVR.ATO.TPAR.W00017"
                test="not(                   
                        pyde.02.00:PersonNameDetails.PersonNameType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'LGL']
                        and pyde.02.05:PersonNameDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'IDENTIFIER']
                        and pyde.02.00:PersonNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                        and pyde.02.00:PersonNameDetails.Title.Text[ not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and string-length(normalize-space(.)) != 0
                        and not(
                              exslt:uppercase(normalize-space(.)) = '2LT' or
                              exslt:uppercase(normalize-space(.)) = 'AB' or
                              exslt:uppercase(normalize-space(.)) = 'ABBOT' or
                              exslt:uppercase(normalize-space(.)) = 'AC' or
                              exslt:uppercase(normalize-space(.)) = 'ACM' or
                              exslt:uppercase(normalize-space(.)) = 'ACW' or
                              exslt:uppercase(normalize-space(.)) = 'ADM' or
                              exslt:uppercase(normalize-space(.)) = 'AIR CDRE' or
                              exslt:uppercase(normalize-space(.)) = 'ALDERMAN' or
                              exslt:uppercase(normalize-space(.)) = 'AM' or
                              exslt:uppercase(normalize-space(.)) = 'AMBSR' or
                              exslt:uppercase(normalize-space(.)) = 'ARCHBISHOP' or
                              exslt:uppercase(normalize-space(.)) = 'ARCHDEACON' or
                              exslt:uppercase(normalize-space(.)) = 'ASSOC PROF' or
                              exslt:uppercase(normalize-space(.)) = 'AVM' or
                              exslt:uppercase(normalize-space(.)) = 'BARON' or
                              exslt:uppercase(normalize-space(.)) = 'BARONESS' or
                              exslt:uppercase(normalize-space(.)) = 'BDR' or
                              exslt:uppercase(normalize-space(.)) = 'BISHOP' or
                              exslt:uppercase(normalize-space(.)) = 'BR' or
                              exslt:uppercase(normalize-space(.)) = 'BRIG' or
                              exslt:uppercase(normalize-space(.)) = 'CANON' or
                              exslt:uppercase(normalize-space(.)) = 'CAPT' or
                              exslt:uppercase(normalize-space(.)) = 'CARDINAL' or
                              exslt:uppercase(normalize-space(.)) = 'CDRE' or
                              exslt:uppercase(normalize-space(.)) = 'CDT' or
                              exslt:uppercase(normalize-space(.)) = 'CHAP' or
                              exslt:uppercase(normalize-space(.)) = 'CMDR' or
                              exslt:uppercase(normalize-space(.)) = 'CMM' or
                              exslt:uppercase(normalize-space(.)) = 'COL' or
                              exslt:uppercase(normalize-space(.)) = 'CONST' or
                              exslt:uppercase(normalize-space(.)) = 'CONSUL' or
                              exslt:uppercase(normalize-space(.)) = 'COUNT' or
                              exslt:uppercase(normalize-space(.)) = 'COUNTESS' or
                              exslt:uppercase(normalize-space(.)) = 'CPL' or
                              exslt:uppercase(normalize-space(.)) = 'CPO' or
                              exslt:uppercase(normalize-space(.)) = 'DAME' or
                              exslt:uppercase(normalize-space(.)) = 'DEACON' or
                              exslt:uppercase(normalize-space(.)) = 'DEACONESS' or
                              exslt:uppercase(normalize-space(.)) = 'DEAN' or
                              exslt:uppercase(normalize-space(.)) = 'DEPUTY SUPT' or
                              exslt:uppercase(normalize-space(.)) = 'DIRECTOR' or
                              exslt:uppercase(normalize-space(.)) = 'DR' or
                              exslt:uppercase(normalize-space(.)) = 'DUCHESS' or
                              exslt:uppercase(normalize-space(.)) = 'DUKE' or
                              exslt:uppercase(normalize-space(.)) = 'EARL' or
                              exslt:uppercase(normalize-space(.)) = 'EF' or
                              exslt:uppercase(normalize-space(.)) = 'ENGR' or
                              exslt:uppercase(normalize-space(.)) = 'FLGOFF' or
                              exslt:uppercase(normalize-space(.)) = 'FLT LT' or
                              exslt:uppercase(normalize-space(.)) = 'FR' or
                              exslt:uppercase(normalize-space(.)) = 'FSGT' or
                              exslt:uppercase(normalize-space(.)) = 'GEN' or
                              exslt:uppercase(normalize-space(.)) = 'GNR' or
                              exslt:uppercase(normalize-space(.)) = 'GOV' or
                              exslt:uppercase(normalize-space(.)) = 'GP CAPT' or
                              exslt:uppercase(normalize-space(.)) = 'HON' or
                              exslt:uppercase(normalize-space(.)) = 'HON JUDGE' or
                              exslt:uppercase(normalize-space(.)) = 'HON JUST' or
                              exslt:uppercase(normalize-space(.)) = 'HRH' or
                              exslt:uppercase(normalize-space(.)) = 'INSP' or
                              exslt:uppercase(normalize-space(.)) = 'JUDGE' or
                              exslt:uppercase(normalize-space(.)) = 'JUST' or
                              exslt:uppercase(normalize-space(.)) = 'LAC' or
                              exslt:uppercase(normalize-space(.)) = 'LACW' or
                              exslt:uppercase(normalize-space(.)) = 'LADY' or
                              exslt:uppercase(normalize-space(.)) = 'LBDR' or
                              exslt:uppercase(normalize-space(.)) = 'LCPL' or
                              exslt:uppercase(normalize-space(.)) = 'LEUT' or
                              exslt:uppercase(normalize-space(.)) = 'LORD' or
                              exslt:uppercase(normalize-space(.)) = 'LS' or
                              exslt:uppercase(normalize-space(.)) = 'LT' or
                              exslt:uppercase(normalize-space(.)) = 'LT CMDR' or
                              exslt:uppercase(normalize-space(.)) = 'LT COL' or
                              exslt:uppercase(normalize-space(.)) = 'LT GEN' or
                              exslt:uppercase(normalize-space(.)) = 'LTGOV' or
                              exslt:uppercase(normalize-space(.)) = 'MADAM' or
                              exslt:uppercase(normalize-space(.)) = 'MADAME' or
                              exslt:uppercase(normalize-space(.)) = 'MAJ' or
                              exslt:uppercase(normalize-space(.)) = 'MAJ GEN' or
                              exslt:uppercase(normalize-space(.)) = 'MASTER' or
                              exslt:uppercase(normalize-space(.)) = 'MATRON' or
                              exslt:uppercase(normalize-space(.)) = 'MAYOR' or
                              exslt:uppercase(normalize-space(.)) = 'MAYORESS' or
                              exslt:uppercase(normalize-space(.)) = 'MGR' or
                              exslt:uppercase(normalize-space(.)) = 'MIDN' or
                              exslt:uppercase(normalize-space(.)) = 'MISS' or
                              exslt:uppercase(normalize-space(.)) = 'MON' or
                              exslt:uppercase(normalize-space(.)) = 'MOST REV' or
                              exslt:uppercase(normalize-space(.)) = 'MR' or
                              exslt:uppercase(normalize-space(.)) = 'MRS' or
                              exslt:uppercase(normalize-space(.)) = 'MS' or
                              exslt:uppercase(normalize-space(.)) = 'NURSE' or
                              exslt:uppercase(normalize-space(.)) = 'OCDT' or
                              exslt:uppercase(normalize-space(.)) = 'PASTOR' or
                              exslt:uppercase(normalize-space(.)) = 'PATRIARCH' or
                              exslt:uppercase(normalize-space(.)) = 'PLT OFF' or
                              exslt:uppercase(normalize-space(.)) = 'PO' or
                              exslt:uppercase(normalize-space(.)) = 'PRIOR' or
                              exslt:uppercase(normalize-space(.)) = 'PROF' or
                              exslt:uppercase(normalize-space(.)) = 'PTE' or
                              exslt:uppercase(normalize-space(.)) = 'RABBI' or
                              exslt:uppercase(normalize-space(.)) = 'RADM' or
                              exslt:uppercase(normalize-space(.)) = 'RECTOR' or
                              exslt:uppercase(normalize-space(.)) = 'REG SGT MJR' or
                              exslt:uppercase(normalize-space(.)) = 'REV' or
                              exslt:uppercase(normalize-space(.)) = 'RF' or
                              exslt:uppercase(normalize-space(.)) = 'RT HON' or
                              exslt:uppercase(normalize-space(.)) = 'RT REV' or
                              exslt:uppercase(normalize-space(.)) = 'RT REV BISHOP' or
                              exslt:uppercase(normalize-space(.)) = 'RT REV MON' or
                              exslt:uppercase(normalize-space(.)) = 'SBLT' or
                              exslt:uppercase(normalize-space(.)) = 'SCDT' or
                              exslt:uppercase(normalize-space(.)) = 'SEN' or
                              exslt:uppercase(normalize-space(.)) = 'SGT' or
                              exslt:uppercase(normalize-space(.)) = 'SIR' or
                              exslt:uppercase(normalize-space(.)) = 'SISTER SUP' or
                              exslt:uppercase(normalize-space(.)) = 'SM' or
                              exslt:uppercase(normalize-space(.)) = 'SMN' or
                              exslt:uppercase(normalize-space(.)) = 'SNR' or
                              exslt:uppercase(normalize-space(.)) = 'SNR CONST' or
                              exslt:uppercase(normalize-space(.)) = 'SQN LDR' or
                              exslt:uppercase(normalize-space(.)) = 'SR' or
                              exslt:uppercase(normalize-space(.)) = 'SSGT' or
                              exslt:uppercase(normalize-space(.)) = 'SUPR' or
                              exslt:uppercase(normalize-space(.)) = 'SWAMI' or
                              exslt:uppercase(normalize-space(.)) = 'TF' or
                              exslt:uppercase(normalize-space(.)) = 'VADM' or
                              exslt:uppercase(normalize-space(.)) = 'VCE CMNDR' or
                              exslt:uppercase(normalize-space(.)) = 'VERY REV' or
                              exslt:uppercase(normalize-space(.)) = 'VICAR' or
                              exslt:uppercase(normalize-space(.)) = 'VISCOUNT' or
                              exslt:uppercase(normalize-space(.)) = 'WG CDR' or
                              exslt:uppercase(normalize-space(.)) = 'WO' or
                              exslt:uppercase(normalize-space(.)) = 'WO1' or
                              exslt:uppercase(normalize-space(.)) = 'WO2' or
                              exslt:uppercase(normalize-space(.)) = 'WOFF'
                            )]
                   )"
                />
       <!-- 
        IF [TPAR90] <> NULLORBLANK  AND [TPAR90] <> SET(DOMAIN(SUFFIX CODES))
            RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR90] = TPAR:Payee.{ABN}.{BranchCode}:pyde.02.00:PersonNameDetails.NameSuffix.Text 
        WHERE (pyde.02.00:PersonNameDetails.PersonNameType.Code = "LGL" AND pyde.02.05:PersonNameDetails.Usage.Code = "Identifier" AND pyde.02.00:PersonNameDetails.Currency.Code = "C") 
        IN TUPLE(prsnstrcnm3.02.01:PersonNameDetails)
   
       -->

        <assert id="VR.ATO.TPAR.W00018" diagnostics="DVR.ATO.TPAR.W00018"
                test="not(                   
                        pyde.02.00:PersonNameDetails.PersonNameType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'LGL']
                        and pyde.02.05:PersonNameDetails.Usage.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'IDENTIFIER']
                        and pyde.02.00:PersonNameDetails.Currency.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'C']
                        and pyde.02.00:PersonNameDetails.NameSuffix.Text[ not(@i:nil='true' or @i:nil='1') and @contextRef = $PAYEE.ContextId and string-length(normalize-space(.)) != 0
                        and not(
                            exslt:uppercase(normalize-space(.)) = 'ESQ' or
                            exslt:uppercase(normalize-space(.)) = 'II' or
                            exslt:uppercase(normalize-space(.)) = 'III' or
                            exslt:uppercase(normalize-space(.)) = 'IV' or
                            exslt:uppercase(normalize-space(.)) = 'JNR' or
                            exslt:uppercase(normalize-space(.)) = 'JP' or
                            exslt:uppercase(normalize-space(.)) = 'MHA' or
                            exslt:uppercase(normalize-space(.)) = 'MHR' or
                            exslt:uppercase(normalize-space(.)) = 'MLA' or
                            exslt:uppercase(normalize-space(.)) = 'MLC' or
                            exslt:uppercase(normalize-space(.)) = 'MP' or
                            exslt:uppercase(normalize-space(.)) = 'QC' or
                            exslt:uppercase(normalize-space(.)) = 'SNR'
                            )]
                        )"
                />
        
        
        
    </rule>
 
    
    <rule context="declaration1.02.01:Declaration[not(@i:nil='true' or @i:nil='1')]">
        <!--
        
        IF [TPAR129] <> NULL AND [TPAR129] > DATE(TODAY)
            RETURN VALIDATION MESSAGE
        ENDIF

        [TPAR129] = TPAR:INT:pyin.02.00:Declaration.Signature.Date 
        WHERE (pyin.02.03:Declaration.StatementType.Code = "TrueAndCorrect") 
        IN TUPLE(declaration1.02.01:Declaration)  
        
        -->
    <assert id="VR.ATO.TPAR.W00033" diagnostics="DVR.ATO.TPAR.W00033"
            test="not(          
                        pyin.02.03:Declaration.StatementType.Code[not(@i:nil='true' or @i:nil='1') and exslt:uppercase(.) = 'TRUEANDCORRECT']  
                        and
                        function:IsDate1GreaterThanDate2
                        (
                          pyin.02.00:Declaration.Signature.Date [@contextRef = $INT.ContextId and not(@i:nil='true' or @i:nil='1')]/text(), 
                          date:date-time()
                        )
                      )"/>

    </rule>
</pattern>
